import { GatsbyCache } from 'gatsby';
/**
 * The GraphQL type of the fluid field.
 * Corresponding TS type is FluidObject from gatsby-image.
 */
import { FixedObject, FluidObject } from 'gatsby-image';
import { GraphQLEnumType, GraphQLInputObjectType, GraphQLObjectType } from 'gatsby/graphql';
export declare const ImgixParamsInputType: GraphQLInputObjectType;
export declare const createImgixFluidType: ({ cache, name, }: {
    name?: string | undefined;
    cache: GatsbyCache;
}) => GraphQLObjectType<FluidObject, unknown>;
export declare const getImgixFluidType: (args: Parameters<typeof createImgixFluidType>) => GraphQLObjectType<FluidObject, unknown>;
export declare const createImgixFixedType: ({ name, cache, }: {
    name?: string | undefined;
    cache: GatsbyCache;
}) => GraphQLObjectType<FixedObject>;
export declare const unTransformParams: <T>(params: Record<string, T>) => Record<string, T>;
export declare type IGatsbySourceImgixUrlField = string;
export declare const gatsbySourceImgixUrlFieldType: import("gatsby/graphql").GraphQLScalarType;
export declare const ImgixPlaceholderType: GraphQLEnumType;
//# sourceMappingURL=graphqlTypes.d.ts.map