/**
 * This function is a helper function which is designed to return a set of breakpoints that can be passed to `getImageData` from gatsby-plugin-image.
 *
 * @returns breakpoints and breakpointsWithData. breakpoints can be passed straight to gatsby-plugin-image, and breakpointsWithData should be passed as args to the buildUrl function so that it can apply variable quality for fixed srcsets.
 */
export declare const generateBreakpoints: (opts: ({
    layout: 'fullWidth';
    width?: undefined;
} | {
    layout: 'fixed' | 'constrained';
    width: number;
}) & {
    srcsetMinWidth?: number | undefined;
    srcsetMaxWidth?: number | undefined;
    widthTolerance?: number | undefined;
    sourceWidth?: number | undefined;
    disableVariableQuality?: boolean | undefined;
}) => {
    breakpoints: number[];
    breakpointsWithData?: {
        width: number;
        quality: number;
    }[];
};
//# sourceMappingURL=breakpoints.d.ts.map