"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getGatsbyImageData = exports.GATSBY_IMAGE_HOOK_OPTS_KEYS = void 0;
var gatsby_plugin_image_1 = require("gatsby-plugin-image");
var uri_1 = require("../../common/uri");
var common_1 = require("./common");
var urlBuilder = function (client) { return function (_a) {
    var baseUrl = _a.baseUrl, width = _a.width, height = _a.height, _b = _a.options, options = _b === void 0 ? {} : _b;
    // TODO: handle default params
    return client.buildURL(baseUrl, __assign(__assign({ fit: 'min' }, options.imgixParams), { w: width, h: height }));
}; };
// This is a workaround to ensure that the props that are extracted in the component are always in sync with this hook's options
exports.GATSBY_IMAGE_HOOK_OPTS_KEYS = [
    'src',
    'imgixParams',
    'width',
    'height',
    'layout',
    'breakpoints',
    'widthTolerance',
    'srcsetMinWidth',
    'srcsetMaxWidth',
    'aspectRatio',
    'sourceWidth',
    'sourceHeight',
    'backgroundColor',
];
// This is the actual type check. It ensures that a key of the object type can be "assigned" to a key of the list above. Therefore if a new key is added to the opts type, this will throw a type error
var __KEY_CHECK = '';
function getGatsbyImageData(_a) {
    var src = _a.src, sourceWidth = _a.sourceWidth, sourceHeight = _a.sourceHeight, aspectRatio = _a.aspectRatio, props = __rest(_a, ["src", "sourceWidth", "sourceHeight", "aspectRatio"]);
    var bothWidthAndHeightSet = props.width != null && props.height != null;
    var sourceOrAspectRatioSet = (sourceWidth != null && sourceHeight != null) || aspectRatio != null;
    if (!bothWidthAndHeightSet && !sourceOrAspectRatioSet) {
        throw new Error("[@imgix/gatsby] 'aspectRatio' or 'sourceWidth' and 'sourceHeight' needed when one of width/height are not passed.");
    }
    var client = common_1.createImgixClient({
        domain: uri_1.parseHost(src),
        libraryParam: 'gatsbyHook',
    });
    // TODO: use @imgix/js-core breakpoints
    return gatsby_plugin_image_1.getImageData(__assign(__assign({ baseUrl: uri_1.parsePath(src), sourceWidth: sourceWidth,
        sourceHeight: sourceHeight,
        aspectRatio: aspectRatio, urlBuilder: urlBuilder(client), pluginName: '@imgix/gatsby', formats: ['auto'] }, props), { options: {
            imgixParams: props.imgixParams,
        } }));
}
exports.getGatsbyImageData = getGatsbyImageData;
//# sourceMappingURL=gatsbyPluginImage.js.map